=== modified file 'src/com/goldencode/p2j/ui/LogicalTerminal.java'
--- old/src/com/goldencode/p2j/ui/LogicalTerminal.java	2022-08-17 07:58:35 +0000
+++ new/src/com/goldencode/p2j/ui/LogicalTerminal.java	2022-09-06 18:22:04 +0000
@@ -995,6 +995,13 @@
 **     TW  20220803          Error-status:error must be set for return error in method, while return error
 **                           in old-style ABL function must remain the same. Refs: #6567.
 **     TW  20220817          Error-status:error must be set for return error in static method.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
+**     CA  20220906          Moved the interactive client cleaner to LogicalTerminal.registerCleaner().
 */
 
 /*
@@ -1621,6 +1628,44 @@
    {
       defaultTimeout = timeout;
    }
+
+   /**
+    * Register a cleaner for interactive sessions, where a pause is shown before terminating the client.
+    */
+   public static void registerCleaner()
+   {
+      if (!AppServerManager.isRemote() && !TransactionManager._isHeadless())
+      {
+         Finalizable cleaner = new Finalizable()
+         {
+            @Override
+            public void finished()
+            {
+               LogicalTerminal.getInstance().pauseBeforeEnd(TransactionManager.isProcessingQuit());
+            }
+            
+            @Override
+            public void iterate()
+            {
+               // nothing to do here 
+            }
+            
+            @Override
+            public void retry()
+            {
+               // nothing to do here 
+            }
+            
+            @Override
+            public void deleted()
+            {
+               // nothing to do here
+            }
+         };
+            
+         TransactionManager.registerFinalizable(cleaner, true);
+      }
+   }
    
    /**
     * Rings a bell on the terminal.
@@ -1703,7 +1748,7 @@
       }
       
       LogicalTerminal lt = locate();
-      lt.scopeTrack.forceHiding();
+      lt.forceHiding();
       lt.client.hideAll(noPause, targetWindowWorker(hWin, false));
       
       // TODO get frames from target window?
@@ -9364,7 +9409,7 @@
       
       LogicalTerminal lt = locate();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       frame.setHadView();
 
       // refresh editable frames list
@@ -9405,7 +9450,7 @@
       
       LogicalTerminal lt = locate();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       frame.setHadView();
 
       // refresh editable frames list
@@ -9519,7 +9564,7 @@
       ScreenBuffer[] frameBuf = (frame == null) ? null : lt.getEditableServerScreenBuffers(frame); 
       int          windowId = (frame == null) ? WindowConfig.RESOLVE_WINDOW : frame.getWindowId();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       FieldGroup fg;
       if (frame != null)
       {
@@ -9549,7 +9594,7 @@
    {
       LogicalTerminal lt = locate();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       
       view(frame.getFrameId(),
            lt.getEditableServerScreenBuffers(frame),
@@ -9577,7 +9622,7 @@
    {
       LogicalTerminal lt = locate();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       
       view(frame.getFrameId(),
            lt.getEditableServerScreenBuffers(frame),
@@ -9625,7 +9670,7 @@
    {
       LogicalTerminal lt = locate();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       
       WidgetConfig[] wcfgs = lt.client.view(frame.getFrameId(),
                                             lt.getEditableServerScreenBuffers(frame),
@@ -9669,7 +9714,7 @@
    {
       LogicalTerminal lt = locate();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       
       FieldGroup fg = frame.getFieldGroup();
       
@@ -9724,7 +9769,7 @@
    {
       LogicalTerminal lt = locate();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       
       WidgetConfig[] wcfgs = lt.client.view(frame.getFrameId(),
                                             lt.getEditableServerScreenBuffers(frame),
@@ -9760,7 +9805,7 @@
    {
       LogicalTerminal lt = locate();
       
-      lt.scopeTrack.frameViewed(frame);
+      lt.frameViewed(frame);
       
       view(frame.getFrameId(),
            frameBuf,
@@ -9810,7 +9855,7 @@
       // call the client
       try
       {
-         lt.scopeTrack.frameViewed(frame);
+         lt.frameViewed(frame);
          
          int[] tabItemList = frame.updateTabItemsList(widgetIds, UpdatesOp.PROMPT_FOR);
          
@@ -10155,7 +10200,9 @@
       // we haven't had the chance to mark the next partition yet because
       // scopeStart() won't be called until the business logic initializer
       // is complete
-      locate().level2definitions.add(frameDef);
+      LogicalTerminal lt = locate();
+      lt.level2definitions.add(frameDef);
+      lt.tm.registerPendingScopeable(lt);
    }
 
    /**
@@ -10171,7 +10218,9 @@
       // we haven't had the chance to mark the next partition yet because
       // scopeStart() won't be called until the business logic initializer
       // is complete
-      locate().level2descriptions.add(menuDescr);
+      LogicalTerminal lt = locate();
+      lt.level2descriptions.add(menuDescr);
+      lt.tm.registerPendingScopeable(lt);
    }
    
    /**
@@ -10193,6 +10242,8 @@
    public static void processDeferredPush(boolean fromLevel2)
    {
       LogicalTerminal lt = locate();
+      lt.tm.registerBlockScopeable(lt);
+
       if (fromLevel2)
       {
          lt.definitions.markPartition();
@@ -11372,7 +11423,14 @@
     */
    static void deregisterFrame(int frameId)
    {
-      locate().deregisterFrameInt(frameId);
+      LogicalTerminal lt = locate();
+      
+      // scopeable registration must be done in any location where a frame state (requiring scope support) is
+      // being 'touched' - this includes frame de-registration, even if the current block is not explicitly
+      // using frames
+      lt.tm.registerBlockScopeable(lt);
+
+      lt.deregisterFrameInt(frameId);
    }
    
    /**
@@ -11815,8 +11873,35 @@
          return frameRegistry.get(frameId);
       }
    }
+   
+   /**
+    * Notify scope that frame is viewed.
+    * <p>
+    * This also registeres {@link LogicalTerminal} for scope notifications at the current block.
+    *  
+    * @param   frame
+    *          Frame which is about to be viewed.
+    */
+   private void frameViewed(GenericFrame frame)
+   {
+      tm.registerBlockScopeable(this);
+      
+      scopeTrack.frameViewed(frame);
+   }
 
    /**
+    * Clear map of viewed frames.
+    * <p>
+    * This also registeres {@link LogicalTerminal} for scope notifications at the current block.
+    */
+   private void forceHiding()
+   {
+      tm.registerBlockScopeable(this);
+      
+      scopeTrack.forceHiding();
+   }
+   
+   /**
     * Save the {@link UIStatement} running for each registered frame.
     * 
     * @return   A map with each frame's UI statement.
@@ -13298,23 +13383,6 @@
    }
    
    /**
-    * Register with the {@link com.goldencode.p2j.util.TransactionManager TransactionManager} a
-    * factory object which creates instances of this class, so that they can be registered to
-    * receive notifications of runtime scope start and finish events.
-    * <p>
-    * This method should be invoked once during the server bootstrap phase.
-    * <p>
-    * The registered factory functions conditionally. It uses the {@link 
-    * TransactionManager#_isHeadless()} to check whether the context has been declared headless.
-    */
-   public static void initialize()
-   {
-      TransactionManager.registerScopeableFactory(
-         () -> TransactionManager._isHeadless() ? null : LogicalTerminal.locate() 
-      );
-   }
-   
-   /**
     * Process a notification that a new block scope is about to be entered.
     * <p>
     * In the Logical Terminal, a new top level block scope causes creation of
@@ -13325,6 +13393,9 @@
    @Override
    public void scopeStart()
    {
+      // scopeable registration is done in different places - if changes are made, ensure that scopeable 
+      // support is registered properly.
+      
       // register at each scope, it is important to instantiate the scope
       // processor BEFORE the state.interactions counter is reset below
       tm.registerFinalizable(new ScopeProcessor(), false);
@@ -13342,39 +13413,6 @@
          state.interactions = 0;
       }
       
-      // make sure that the global block gets a special notification - but only for non-appserver sessions.
-      if (tm.isGlobalBlock() && !tm.isRemote())
-      {
-         Finalizable cleaner = new Finalizable()
-         {
-            @Override
-            public void finished()
-            {
-               pauseBeforeEnd(tm.isProcessingQuit());
-            }
-            
-            @Override
-            public void iterate()
-            {
-               // nothing to do here 
-            }
-            
-            @Override
-            public void retry()
-            {
-               // nothing to do here 
-            }
-            
-            @Override
-            public void deleted()
-            {
-               // nothing to do here
-            }
-         };
-         
-         tm.registerFinalizable(cleaner, true);
-      }
-
       // add a new scope for each top-level block
       if (tm.isTopLevelBlock())
       {
@@ -13463,6 +13501,17 @@
    }
    
    /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   {@link ScopeId#LOGICAL_TERMINAL}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      return ScopeId.LOGICAL_TERMINAL;
+   }
+   
+   /**
     * Called by the protocol driver to obtain the latest state that should
     * be sent to the other side of the connection.  This is called just 
     * before a "real" message is sent and any changes provided will be
@@ -13589,6 +13638,12 @@
          
          if (cs.deregister != null)
          {
+            // scopeable registration must be done in any location where a frame state (requiring scope 
+            // support) is being 'touched' - this includes frame de-registration, even if the current block 
+            // is not explicitly using frames
+
+            tm.registerBlockScopeable(this);
+
             for (int i : cs.deregister)
             {
                deregisterFrameInt(i);
@@ -13605,6 +13660,8 @@
          
          if (cs.wrapped != null && scopeTrack != null)
          {
+            tm.registerBlockScopeable(this);
+            
             for (int id : cs.wrapped)
             {
                scopeTrack.frameWrapped(id);

=== modified file 'src/com/goldencode/p2j/ui/MenuContainerWidget.java'
--- old/src/com/goldencode/p2j/ui/MenuContainerWidget.java	2020-11-17 20:03:34 +0000
+++ new/src/com/goldencode/p2j/ui/MenuContainerWidget.java	2022-09-06 18:22:04 +0000
@@ -2,7 +2,7 @@
 ** Module   : MenuContainerWidget.java
 ** Abstract : The base class for MenuWidget and SubMenuWidget.
 **
-** Copyright (c) 2015-2020, Golden Code Development Corporation.
+** Copyright (c) 2015-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description----------------------------------
 ** 001 VIG 20150115 Created initial version.
@@ -34,6 +34,12 @@
 **     EVL 20201021 More optimization for getAttr() usage or widget ID getting.
 **     EVL 20201022 Optimized attributes flush implementation.
 **     CA  20201117 Do not use resourceDelete to delete the widget - use the delete() API for this code.
+**     CA  20220901 Refactored scope notification support: ScopeableFactory was removed, and the registration 
+**                  is now specific to each type of scopeable.  For each case, the block will be registered 
+**                  for scope support (for that particular scopeable) only when the scopeable is 'active' 
+**                  (i.e. unnamed streams or accumulators are used).  This allows a lazy registration of 
+**                  scopeables, to avoid the unnecessary overhead of processing all the scopeables for each
+**                  and every block.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -494,6 +500,8 @@
       // push down the screen definition
       if (force)
       {
+         TransactionManager.registerBlockScopeable(LogicalTerminal.getInstance());
+
          // synchronous push
          MenuDescription[] sd = new MenuDescription[] {root.menuDef};
          LogicalTerminal.pushMenuDescription(sd);

=== modified file 'src/com/goldencode/p2j/ui/TriggerManager.java'
--- old/src/com/goldencode/p2j/ui/TriggerManager.java	2022-01-26 15:36:52 +0000
+++ new/src/com/goldencode/p2j/ui/TriggerManager.java	2022-09-06 18:22:04 +0000
@@ -56,6 +56,12 @@
 **                           the resource gets deleted (including widgets).
 **     CA  20210917          Javadoc fixes.
 **     SBI 20220126          Fixed scopeFinished to add preserved events before all events from the target list.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -190,6 +196,8 @@
                                EventList             events, 
                                int                   tid)
    {
+      TransactionManager.registerBlockScopeable(LogicalTerminal.getInstance());
+
       events.setTriggerId(tid);
 
       // insert the latest trigger def at the front of the list. all created triggers are saved,
@@ -261,6 +269,8 @@
    @SuppressWarnings("unchecked")
    public static void deregister(ScopedDictionary<?,?> registry, EventList el)
    {
+      TransactionManager.registerBlockScopeable(LogicalTerminal.getInstance());
+
       LinkedList<EventList> registryScope = null;
 
       // DEBUG: System.err.printf("DEREGISTER\nBEFORE %s", dumpRegistry(registry));

=== modified file 'src/com/goldencode/p2j/util/AbstractParameter.java'
--- old/src/com/goldencode/p2j/util/AbstractParameter.java	2021-06-14 10:34:33 +0000
+++ new/src/com/goldencode/p2j/util/AbstractParameter.java	2022-09-06 18:22:04 +0000
@@ -3,7 +3,7 @@
 ** Abstract : Common logic for assigns [input-]output parameter values (database fields and normal
 **            variables) upon exit from procedure/function
 **
-** Copyright (c) 2015-2021, Golden Code Development Corporation.
+** Copyright (c) 2015-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------------Description----------------------------------------
 ** 001 OM  20150702 First version based on extracted code form AbstractSimpleParameter and
@@ -18,6 +18,13 @@
 **                  in the parameter instance must be replaced.
 **     CA  20210609 Reworked INPUT/INPUT-OUTPUT parameters to a new approach, where they are explicitly 
 **                  initialized at the method's execution, and not at the caller's arguments.
+**     CA  20220901 Refactored scope notification support: ScopeableFactory was removed, and the registration 
+**                  is now specific to each type of scopeable.  For each case, the block will be registered 
+**                  for scope support (for that particular scopeable) only when the scopeable is 'active' 
+**                  (i.e. unnamed streams or accumulators are used).  This allows a lazy registration of 
+**                  scopeables, to avoid the unnecessary overhead of processing all the scopeables for each
+**                  and every block.
+**     CA  20220906 Parameter scope notifications is required for all OUTPUT parameters, not just fields.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -76,6 +83,7 @@
 
 import com.goldencode.p2j.persist.*;
 import com.goldencode.p2j.security.*;
+
 import java.lang.reflect.*;
 import java.util.*;
 import java.util.logging.*;
@@ -134,6 +142,15 @@
    };
    
    /**
+    * Default constructor - register the {@link WorkArea scopeable} instance as pending for the next started
+    * block.
+    */
+   public AbstractParameter()
+   {
+      TransactionManager.registerPendingScopeable(getScopeable());
+   }
+   
+   /**
     * Retrieve a {@code Scopeable} for the current context. This allows an external object to
     * notify this class' current context of scope open and close events.
     *
@@ -338,6 +355,17 @@
       }
       
       /**
+       * Get the {@link ScopeId} for the instance.
+       * 
+       * @return   {@link ScopeId#ABSTRACT_PARAMETER}.
+       */
+      @Override
+      public ScopeId getScopeId()
+      {
+         return ScopeId.ABSTRACT_PARAMETER;
+      }
+      
+      /**
        * Get the object which manages field assigners for the current scope.
        *
        * @return  Current scope.

=== modified file 'src/com/goldencode/p2j/util/Accumulator.java'
--- old/src/com/goldencode/p2j/util/Accumulator.java	2019-03-26 11:53:52 +0000
+++ new/src/com/goldencode/p2j/util/Accumulator.java	2022-09-06 18:22:04 +0000
@@ -2,7 +2,7 @@
 ** Module   : Accumulator.java
 ** Abstract : Abstract base class for concrete accumulator implementations
 **
-** Copyright (c) 2004-2019, Golden Code Development Corporation.
+** Copyright (c) 2004-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --JPRM-- -----------------------------Description-----------------------------
 ** 001 ECF 20051227   @23778 Created initial version. Base class for
@@ -117,6 +117,12 @@
 **                           when reset() called without accumulate().
 ** 028 CA  20190326          Implemented TransactionHelper instead of direct usage of the static   
 **                           API.  This allows the elimination of context local usage in TM.
+** 029 CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -1099,6 +1105,18 @@
    {
       // no-op
    }
+   
+   /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   <code>null</code>, as the scope notification is done via {@link AccumulatorManager}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      // no ID necessary, as it does not get registered explicitly, is called via AccumulatorManager
+      return null;
+   }
 
    /**
     * Process a notification that a new block scope has been entered. Each 

=== modified file 'src/com/goldencode/p2j/util/AccumulatorManager.java'
--- old/src/com/goldencode/p2j/util/AccumulatorManager.java	2021-03-10 18:41:30 +0000
+++ new/src/com/goldencode/p2j/util/AccumulatorManager.java	2022-09-06 18:22:04 +0000
@@ -2,7 +2,7 @@
 ** Module   : AccumulatorManager.java
 ** Abstract : provides block-behavior for the accumulators.
 **
-** Copyright (c) 2008-2021, Golden Code Development Corporation.
+** Copyright (c) 2008-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- -T- --JPRM-- ----------------Description-----------------
 ** 001 CA  20080129   @37024 Created initial version. Provides context
@@ -33,6 +33,12 @@
 ** 010 CA  20200930          Refactored to remove the singleton scopeable instance (which forced the scope 
 **                           notifications to use context-local state).
 **     CA  20210310          Small performance improvement.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -107,46 +113,26 @@
  * on a static basis but instead requires an instance method implementation.
  * These instance methods then call the static counterparts which is where
  * the content-local versions of the resource pools are accessed.
- * <p>
- * The initialization processing is implemented in the {@link #initialize}
- * method and it is called during server startup based on an entry in the
- * directory until the path "/server/&lt;serverId&gt;/startup" or in
- * "/server/default/startup".
  *
  * @author    CA
  */
 public class AccumulatorManager
-implements Scopeable,
-           ScopeableFactory
+implements Scopeable
 {
    /** Pool of accums which is context-local. Initializes upon first use. */ 
    private static ContextContainer context = new ContextContainer();
    
    /** The container with the instance state. */
    private final WorkArea wa = new WorkArea();
-   
-   /**
-    * Initialize the accumulator framework. This registers with the
-    * {@link TransactionManager TransactionManager} a factory object which
-    * creates a <code>Scopeable</code> instance.
-    *
-    * @throws  IllegalStateException
-    *          If invoked more than once.
-    */
-   public static void initialize()
-   {
-      TransactionManager.registerScopeableFactory(() -> context.get());
-   }
-   
-   /**
-    * Provides the singleton instance of this class as a
-    * <code>Scopeable</code>.
-    *
-    * @return  This object.
-    */
-   public Scopeable createScopeable()
-   {
-      return this;
+
+   /**
+    * Get the {@link AccumulatorManager} context-local instance.
+    * 
+    * @return   See above.
+    */
+   public static AccumulatorManager getInstance()
+   {
+      return context.get();
    }
    
    /**
@@ -157,7 +143,9 @@
     */
    public static void addAccumulator(Accumulator accum)
    {
-      WorkArea wa = context.get().wa;
+      AccumulatorManager mgr = context.get();
+      WorkArea wa = mgr.wa;
+      wa.tm.registerPendingScopeable(mgr);
       
       if (wa.pendingSet == null)
       {
@@ -239,6 +227,17 @@
       // no-op
    }
    
+   /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   {@link ScopeId#ACCUMULATOR_MANAGER}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      return ScopeId.ACCUMULATOR_MANAGER;
+   }
+   
    /** 
     * Stores global data relating to the state of the current context.
     */

=== modified file 'src/com/goldencode/p2j/util/Agent.java'
--- old/src/com/goldencode/p2j/util/Agent.java	2022-04-05 17:52:31 +0000
+++ new/src/com/goldencode/p2j/util/Agent.java	2022-09-06 18:22:04 +0000
@@ -81,6 +81,12 @@
 **     CA  20220329 Added support for REST services written directly in Java.
 **     CA  20220405 Added authentication and authorization for web requests.  When this is enabled, the target
 **                  API call will be executed under the authenticated FWD context, and not the agent's context.
+**     CA  20220901 Refactored scope notification support: ScopeableFactory was removed, and the registration 
+**                  is now specific to each type of scopeable.  For each case, the block will be registered 
+**                  for scope support (for that particular scopeable) only when the scopeable is 'active' 
+**                  (i.e. unnamed streams or accumulators are used).  This allows a lazy registration of 
+**                  scopeables, to avoid the unnecessary overhead of processing all the scopeables for each
+**                  and every block.
 */
 
 /*
@@ -2592,6 +2598,8 @@
     */
    private void preProcessArguments(String requesterModes, Object[] args)
    {
+      ControlFlowOps.resetReturnValueSetInRootScope();
+      
       String modes = requesterModes;
       if (modes == null || modes.length() != args.length)
       {
@@ -2859,6 +2867,8 @@
       
       // CA: 20210405: this comment is no longer valid.  it is left as a 'warning' for future readers in case
       // the LT/TM initialization order is changed again and STATE-RESET mode gets broken...
+      // CA: 20220831: ScopeableFactory was removed and the comment bellow is no longer valid, but still left
+      // for historical purposes.
       
       // make sure the TM is loaded before LT, as the LT context-local instance is dependent on TM
       // when creating the ScopeableFactory instances, LT will be loaded by TM and this instance
@@ -2877,8 +2887,6 @@
       DatabaseTriggerManager.get();
 
       ProcedureManager.load();
-      ArrayAssigner.load();
-      ObjectOps.load();
 
       // Global scope for keeping buffers states (like BufferManager.allBuffers). This scope must be explicitly
       // popped when the agent context gets reset or when the agent terminates, so the dynamic DMOs and any 

=== modified file 'src/com/goldencode/p2j/util/ArrayAssigner.java'
--- old/src/com/goldencode/p2j/util/ArrayAssigner.java	2021-06-09 14:35:48 +0000
+++ new/src/com/goldencode/p2j/util/ArrayAssigner.java	2022-09-06 18:22:04 +0000
@@ -2,7 +2,7 @@
 ** Module   : ArrayAssigner.java
 ** Abstract : automates the assignment of each element of a BDT array
 **
-** Copyright (c) 2005-2021, Golden Code Development Corporation.
+** Copyright (c) 2005-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------------Description----------------------------------------
 ** 001 GES 20051104   @23229 Provides a simple helper to automate the assignment of each element
@@ -63,6 +63,12 @@
 **     CA  20210322          Fixed dynamic arrays used in persistent programs or OO instances.
 **     CA  20210609          Reworked INPUT/INPUT-OUTPUT parameters to a new approach, where they are explicitly 
 **                           initialized at the method's execution, and not at the caller's arguments.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -138,22 +144,11 @@
       protected WorkArea initialValue()
       {
          WorkArea wa = new WorkArea();
-         TransactionManager.registerScopeable(wa);
          return wa;
       };
    };
 
    /**
-    * Ensure all the context-local data has initialized (to be able to listen for scope 
-    * notifications).
-    */
-   static void load()
-   {
-      // needed to ensure the variable is loaded, so it listens for scope notifications
-      local.get();
-   }
-
-   /**
     * Assigns (mutates the content of) each matching element of a target
     * array based on the corresponding element of the source array.  The
     * source and target arrays must be assignable to each other (must be
@@ -1958,6 +1953,17 @@
       }
       
       /**
+       * Get the {@link ScopeId} for the instance.
+       * 
+       * @return   {@link ScopeId#ARRAY_ASSIGNER}.
+       */
+      @Override
+      public ScopeId getScopeId()
+      {
+         return ScopeId.ARRAY_ASSIGNER;
+      }
+      
+      /**
        * Returns <code>true</code> if the supplied array argument has been
        * previously registered, <code>false</code> otherwise.
        * 
@@ -2010,6 +2016,8 @@
          {
             if (pending)
             {
+               tm.registerPendingScopeable(this);
+               
                pendingDynamicArrays.add(array);
             }
             else

